%PCA          COMPONENT ANALYSIS
%               Z  ->  Standart Scores
%               q  ->  number of components
%               B  ->  weights    F = Z * B
%               A  ->  optimal weights for estimating Z from F = Z*B
%               f  ->  explained variance
%function [B,A,f] = pca (Z,q);
function [B,A,f] = pca (R,q);

%   if (nargin<2), [n,q] = size (Z);
%   else           [n,m] = size (Z); end;
%   R = corrcoef(Z);

   [P,D,Q] = svd (R);
   Kq = Q(:,1:q);
   Dq = D(1:q,1:q);
   N  = eye(q);

   B  = Kq * inv(Dq)^.5 * N;
   A  = (inv(B'*R*B) * B' * R)';
   f = trace(B'*R*R*B*(B'*R*B)^(-1));

%   B  = Kq * inv(Dq)^.5 * N;
%   F  = Z * B;
%   A  = (inv(F'*F) * F' * Z)';
%   f = trace(B'*R*R*B*(B'*R*B)^(-1));

return;
